Index: pacemaker/pengine/test10/coloc-list.exp
===================================================================
--- pacemaker.orig/pengine/test10/coloc-list.exp
+++ pacemaker/pengine/test10/coloc-list.exp
@@ -3,7 +3,7 @@
      <action_set>
       <rsc_op id="13" operation="start" operation_key="rsc1_start_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs>
@@ -22,7 +22,7 @@
      <action_set>
       <rsc_op id="9" operation="monitor" operation_key="rsc1_monitor_0" on_node="node3" on_node_uuid="node3">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node3" CRM_meta_on_node_uuid="node3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -31,7 +31,7 @@
      <action_set>
       <rsc_op id="6" operation="monitor" operation_key="rsc1_monitor_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs/>
@@ -40,7 +40,7 @@
      <action_set>
       <rsc_op id="2" operation="monitor" operation_key="rsc1_monitor_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -49,7 +49,7 @@
      <action_set>
       <rsc_op id="14" operation="start" operation_key="rsc2_start_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -62,7 +62,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="rsc2_monitor_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -71,7 +71,7 @@
      <action_set>
       <rsc_op id="10" operation="monitor" operation_key="rsc3_monitor_0" on_node="node3" on_node_uuid="node3">
         <primitive id="rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node3" CRM_meta_on_node_uuid="node3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -80,7 +80,7 @@
      <action_set>
       <rsc_op id="3" operation="monitor" operation_key="rsc3_monitor_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -89,7 +89,7 @@
      <action_set>
       <rsc_op id="15" operation="start" operation_key="rsc4_start_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc4" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs>
@@ -108,7 +108,7 @@
      <action_set>
       <rsc_op id="11" operation="monitor" operation_key="rsc4_monitor_0" on_node="node3" on_node_uuid="node3">
         <primitive id="rsc4" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node3" CRM_meta_on_node_uuid="node3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -117,7 +117,7 @@
      <action_set>
       <rsc_op id="8" operation="monitor" operation_key="rsc4_monitor_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc4" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs/>
@@ -126,7 +126,7 @@
      <action_set>
       <rsc_op id="4" operation="monitor" operation_key="rsc4_monitor_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc4" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs/>
@@ -135,7 +135,7 @@
      <action_set>
       <rsc_op id="12" operation="monitor" operation_key="rsc5_monitor_0" on_node="node3" on_node_uuid="node3">
         <primitive id="rsc5" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node3" CRM_meta_on_node_uuid="node3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -144,7 +144,7 @@
      <action_set>
       <rsc_op id="5" operation="monitor" operation_key="rsc5_monitor_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc5" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
Index: pacemaker/pengine/test10/coloc-loop.exp
===================================================================
--- pacemaker.orig/pengine/test10/coloc-loop.exp
+++ pacemaker/pengine/test10/coloc-loop.exp
@@ -3,7 +3,7 @@
      <action_set>
       <rsc_op id="11" operation="start" operation_key="rsc1_start_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs>
@@ -22,7 +22,7 @@
      <action_set>
       <rsc_op id="8" operation="monitor" operation_key="rsc1_monitor_0" on_node="node3" on_node_uuid="node3">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node3" CRM_meta_on_node_uuid="node3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -31,7 +31,7 @@
      <action_set>
       <rsc_op id="5" operation="monitor" operation_key="rsc1_monitor_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -40,7 +40,7 @@
      <action_set>
       <rsc_op id="2" operation="monitor" operation_key="rsc1_monitor_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -49,7 +49,7 @@
     <action_set>
       <rsc_op id="12" operation="start" operation_key="rsc2_start_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -68,7 +68,7 @@
      <action_set>
       <rsc_op id="9" operation="monitor" operation_key="rsc2_monitor_0" on_node="node3" on_node_uuid="node3">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node3" CRM_meta_on_node_uuid="node3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -77,7 +77,7 @@
      <action_set>
       <rsc_op id="6" operation="monitor" operation_key="rsc2_monitor_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -86,7 +86,7 @@
      <action_set>
       <rsc_op id="3" operation="monitor" operation_key="rsc2_monitor_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -95,7 +95,7 @@
      <action_set>
       <rsc_op id="13" operation="start" operation_key="rsc3_start_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -114,7 +114,7 @@
     <action_set>
       <rsc_op id="10" operation="monitor" operation_key="rsc3_monitor_0" on_node="node3" on_node_uuid="node3">
         <primitive id="rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node3" CRM_meta_on_node_uuid="node3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -123,7 +123,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="rsc3_monitor_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -132,7 +132,7 @@
      <action_set>
       <rsc_op id="4" operation="monitor" operation_key="rsc3_monitor_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
Index: pacemaker/pengine/test10/coloc-many-one.exp
===================================================================
--- pacemaker.orig/pengine/test10/coloc-many-one.exp
+++ pacemaker/pengine/test10/coloc-many-one.exp
@@ -3,7 +3,7 @@
      <action_set>
       <rsc_op id="11" operation="start" operation_key="rsc1_start_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs>
@@ -22,7 +22,7 @@
      <action_set>
       <rsc_op id="8" operation="monitor" operation_key="rsc1_monitor_0" on_node="node3" on_node_uuid="node3">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node3" CRM_meta_on_node_uuid="node3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -31,7 +31,7 @@
      <action_set>
       <rsc_op id="5" operation="monitor" operation_key="rsc1_monitor_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs/>
@@ -40,7 +40,7 @@
      <action_set>
       <rsc_op id="2" operation="monitor" operation_key="rsc1_monitor_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -49,7 +49,7 @@
      <action_set>
       <rsc_op id="12" operation="start" operation_key="rsc2_start_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -62,7 +62,7 @@
     <action_set>
       <rsc_op id="6" operation="monitor" operation_key="rsc2_monitor_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -71,7 +71,7 @@
      <action_set>
       <rsc_op id="9" operation="monitor" operation_key="rsc3_monitor_0" on_node="node3" on_node_uuid="node3">
         <primitive id="rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node3" CRM_meta_on_node_uuid="node3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -80,7 +80,7 @@
      <action_set>
       <rsc_op id="3" operation="monitor" operation_key="rsc3_monitor_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -89,7 +89,7 @@
      <action_set>
       <rsc_op id="13" operation="start" operation_key="rsc4_start_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc4" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs>
@@ -108,7 +108,7 @@
      <action_set>
       <rsc_op id="10" operation="monitor" operation_key="rsc4_monitor_0" on_node="node3" on_node_uuid="node3">
         <primitive id="rsc4" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node3" CRM_meta_on_node_uuid="node3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -117,7 +117,7 @@
      <action_set>
       <rsc_op id="7" operation="monitor" operation_key="rsc4_monitor_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc4" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs/>
@@ -126,7 +126,7 @@
      <action_set>
       <rsc_op id="4" operation="monitor" operation_key="rsc4_monitor_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc4" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/coloc-negative-group.exp
===================================================================
--- pacemaker.orig/pengine/test10/coloc-negative-group.exp
+++ pacemaker/pengine/test10/coloc-negative-group.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="2" operation="cancel" operation_key="res_Dummy_1_monitor_10000" on_node="lenny-b" on_node_uuid="lenny-b">
         <primitive id="res_Dummy_1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_call_id="3" CRM_meta_interval="10000" CRM_meta_operation="monitor" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_call_id="3" CRM_meta_interval="10000" CRM_meta_on_node="lenny-b" CRM_meta_on_node_uuid="lenny-b" CRM_meta_operation="monitor" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -12,7 +12,7 @@
     <action_set>
       <rsc_op id="1" operation="cancel" operation_key="res_Dummy_3_monitor_10000" on_node="lenny-a" on_node_uuid="lenny-a">
         <primitive id="res_Dummy_3" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_call_id="10" CRM_meta_interval="10000" CRM_meta_operation="monitor" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_call_id="10" CRM_meta_interval="10000" CRM_meta_on_node="lenny-a" CRM_meta_on_node_uuid="lenny-a" CRM_meta_operation="monitor" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/coloc-slave-anti.exp
===================================================================
--- pacemaker.orig/pengine/test10/coloc-slave-anti.exp
+++ pacemaker/pengine/test10/coloc-slave-anti.exp
@@ -32,7 +32,7 @@
      <action_set>
       <rsc_op id="47" operation="monitor" operation_key="fs-1_monitor_20000" on_node="pollux" on_node_uuid="26cfbecf-dc25-42e1-84de-325ca9e457b5">
         <primitive id="fs-1" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_interval="20000" CRM_meta_name="monitor" CRM_meta_start_delay="10000" CRM_meta_timeout="10000"  device="/dev/drbd0" directory="/drbd" fstype="xfs" options="noatime,exec,nosuid,nodev"/>
+        <attributes CRM_meta_interval="20000" CRM_meta_name="monitor" CRM_meta_on_node="pollux" CRM_meta_on_node_uuid="26cfbecf-dc25-42e1-84de-325ca9e457b5" CRM_meta_start_delay="10000" CRM_meta_timeout="10000"  device="/dev/drbd0" directory="/drbd" fstype="xfs" options="noatime,exec,nosuid,nodev"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -45,7 +45,7 @@
      <action_set>
       <rsc_op id="46" operation="start" operation_key="fs-1_start_0" on_node="pollux" on_node_uuid="26cfbecf-dc25-42e1-84de-325ca9e457b5">
         <primitive id="fs-1" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_name="start" CRM_meta_timeout="10000"  device="/dev/drbd0" directory="/drbd" fstype="xfs" options="noatime,exec,nosuid,nodev"/>
+        <attributes CRM_meta_name="start" CRM_meta_on_node="pollux" CRM_meta_on_node_uuid="26cfbecf-dc25-42e1-84de-325ca9e457b5" CRM_meta_timeout="10000"  device="/dev/drbd0" directory="/drbd" fstype="xfs" options="noatime,exec,nosuid,nodev"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -58,7 +58,7 @@
      <action_set>
       <rsc_op id="49" operation="monitor" operation_key="ip-198_monitor_30000" on_node="pollux" on_node_uuid="26cfbecf-dc25-42e1-84de-325ca9e457b5">
         <primitive id="ip-198" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_start_delay="10000" CRM_meta_timeout="15000" cidr_netmask="28"  iflabel="198" ip="80.237.189.198" nic="eth1"/>
+        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_on_node="pollux" CRM_meta_on_node_uuid="26cfbecf-dc25-42e1-84de-325ca9e457b5" CRM_meta_start_delay="10000" CRM_meta_timeout="15000" cidr_netmask="28"  iflabel="198" ip="80.237.189.198" nic="eth1"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -71,7 +71,7 @@
      <action_set>
       <rsc_op id="48" operation="start" operation_key="ip-198_start_0" on_node="pollux" on_node_uuid="26cfbecf-dc25-42e1-84de-325ca9e457b5">
         <primitive id="ip-198" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_name="start" CRM_meta_timeout="10000" cidr_netmask="28"  iflabel="198" ip="80.237.189.198" nic="eth1"/>
+        <attributes CRM_meta_name="start" CRM_meta_on_node="pollux" CRM_meta_on_node_uuid="26cfbecf-dc25-42e1-84de-325ca9e457b5" CRM_meta_timeout="10000" cidr_netmask="28"  iflabel="198" ip="80.237.189.198" nic="eth1"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -87,7 +87,7 @@
      <action_set>
       <rsc_op id="51" operation="monitor" operation_key="apache_monitor_60000" on_node="pollux" on_node_uuid="26cfbecf-dc25-42e1-84de-325ca9e457b5">
         <primitive id="apache" class="ocf" provider="custom" type="apache2"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_start_delay="10000" CRM_meta_timeout="30000" apache2_bin="/usr/sbin/apache2" apache2_config="/etc/apache2/httpd.conf" apache2_listening_check="80.237.189.198:80" apache2_opts="-D STATUS -D INFO -D LANGUAGE -D SSL -D SUEXEC -D PHP5" apache2_pidfile="/var/run/apache2.pid" />
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="pollux" CRM_meta_on_node_uuid="26cfbecf-dc25-42e1-84de-325ca9e457b5" CRM_meta_start_delay="10000" CRM_meta_timeout="30000" apache2_bin="/usr/sbin/apache2" apache2_config="/etc/apache2/httpd.conf" apache2_listening_check="80.237.189.198:80" apache2_opts="-D STATUS -D INFO -D LANGUAGE -D SSL -D SUEXEC -D PHP5" apache2_pidfile="/var/run/apache2.pid" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -100,7 +100,7 @@
      <action_set>
       <rsc_op id="50" operation="start" operation_key="apache_start_0" on_node="pollux" on_node_uuid="26cfbecf-dc25-42e1-84de-325ca9e457b5">
         <primitive id="apache" class="ocf" provider="custom" type="apache2"/>
-        <attributes CRM_meta_name="start" CRM_meta_timeout="30000" apache2_bin="/usr/sbin/apache2" apache2_config="/etc/apache2/httpd.conf" apache2_listening_check="80.237.189.198:80" apache2_opts="-D STATUS -D INFO -D LANGUAGE -D SSL -D SUEXEC -D PHP5" apache2_pidfile="/var/run/apache2.pid" />
+        <attributes CRM_meta_name="start" CRM_meta_on_node="pollux" CRM_meta_on_node_uuid="26cfbecf-dc25-42e1-84de-325ca9e457b5" CRM_meta_timeout="30000" apache2_bin="/usr/sbin/apache2" apache2_config="/etc/apache2/httpd.conf" apache2_listening_check="80.237.189.198:80" apache2_opts="-D STATUS -D INFO -D LANGUAGE -D SSL -D SUEXEC -D PHP5" apache2_pidfile="/var/run/apache2.pid" />
        </rsc_op>
      </action_set>
      <inputs>
Index: pacemaker/pengine/test10/coloc_fp_logic.exp
===================================================================
--- pacemaker.orig/pengine/test10/coloc_fp_logic.exp
+++ pacemaker/pengine/test10/coloc_fp_logic.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="6" operation="monitor" operation_key="A_monitor_10000" on_node="node2" on_node_uuid="1048225984">
         <primitive id="A" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_node="node2" CRM_meta_on_node_uuid="1048225984" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="5" operation="start" operation_key="A_start_0" on_node="node2" on_node_uuid="1048225984">
         <primitive id="A" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="1048225984" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -29,7 +29,7 @@
     <action_set>
       <rsc_op id="4" operation="stop" operation_key="A_stop_0" on_node="node1" on_node_uuid="1031448768">
         <primitive id="A" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="1031448768" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/colocate-primitive-with-clone.exp
===================================================================
--- pacemaker.orig/pengine/test10/colocate-primitive-with-clone.exp
+++ pacemaker/pengine/test10/colocate-primitive-with-clone.exp
@@ -35,7 +35,7 @@
     <action_set>
       <rsc_op id="38" operation="start" operation_key="UmVIPcheck_start_0" on_node="srv04" on_node_uuid="srv04">
         <primitive id="UmVIPcheck" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_start_delay="2000" CRM_meta_timeout="90000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="srv04" CRM_meta_on_node_uuid="srv04" CRM_meta_start_delay="2000" CRM_meta_timeout="90000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -48,7 +48,7 @@
     <action_set>
       <rsc_op id="40" operation="monitor" operation_key="UmIPaddr_monitor_10000" on_node="srv04" on_node_uuid="srv04">
         <primitive id="UmIPaddr" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="srv04" CRM_meta_on_node_uuid="srv04" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -61,7 +61,7 @@
     <action_set>
       <rsc_op id="39" operation="start" operation_key="UmIPaddr_start_0" on_node="srv04" on_node_uuid="srv04">
         <primitive id="UmIPaddr" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_requires="fencing" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="srv04" CRM_meta_on_node_uuid="srv04" CRM_meta_requires="fencing" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -77,7 +77,7 @@
     <action_set>
       <rsc_op id="42" operation="monitor" operation_key="UmDummy01_monitor_10000" on_node="srv04" on_node_uuid="srv04">
         <primitive id="UmDummy01" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="ignore" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="ignore" CRM_meta_on_node="srv04" CRM_meta_on_node_uuid="srv04" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -90,7 +90,7 @@
     <action_set>
       <rsc_op id="41" operation="start" operation_key="UmDummy01_start_0" on_node="srv04" on_node_uuid="srv04">
         <primitive id="UmDummy01" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_requires="fencing" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="srv04" CRM_meta_on_node_uuid="srv04" CRM_meta_requires="fencing" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -106,7 +106,7 @@
     <action_set>
       <rsc_op id="44" operation="monitor" operation_key="UmDummy02_monitor_10000" on_node="srv04" on_node_uuid="srv04">
         <primitive id="UmDummy02" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="standby" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="standby" CRM_meta_on_node="srv04" CRM_meta_on_node_uuid="srv04" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -119,7 +119,7 @@
     <action_set>
       <rsc_op id="43" operation="start" operation_key="UmDummy02_start_0" on_node="srv04" on_node_uuid="srv04">
         <primitive id="UmDummy02" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="standby" CRM_meta_requires="fencing" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="standby" CRM_meta_on_node="srv04" CRM_meta_on_node_uuid="srv04" CRM_meta_requires="fencing" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -134,7 +134,7 @@
   <synapse id="9">
     <action_set>
       <crm_event id="186" operation="do_shutdown" operation_key="do_shutdown-srv01" on_node="srv01" on_node_uuid="srv01">
-        <attributes CRM_meta_op_no_wait="true" />
+        <attributes CRM_meta_on_node="srv01" CRM_meta_on_node_uuid="srv01" CRM_meta_op_no_wait="true" />
         <downed>
           <node id="srv01"/>
         </downed>
